/* EXTMACRO.c
**
** Copyright (c) 1988, Christopher Laforet
** All Rights Reserved
**
*/

#define LINT_ARGS


#include <stdio.h>
#include "ext.h"


#define TRUE	-1
#define FALSE	0


LINE row;
COL col;
short character;
char far *cptr;
PFILE cur_file;
char far zero_length[2];


flagType pascal EXTERNAL prnt_time(argtype,argptr,metaflag)
unsigned short argtype;
ARG far *argptr;
flagType metaflag;
	{
	fExecute("curday \", \" curdate \" at \" curtime");
	}


flagType pascal EXTERNAL open_hilite(argtype,argptr,metaflag)
unsigned short argtype;
ARG far *argptr;
flagType metaflag;
	{
	fExecute("arg setfile");
	}


flagType pascal EXTERNAL special_char(argtype,argptr,metaflag)
unsigned short argtype;
ARG far *argptr;
flagType metaflag;
	{
	DoMessage("Literal Character");
	fExecute("quote");
	}


flagType pascal EXTERNAL upper(argtype,argptr,metaflag)
unsigned short argtype;
ARG far *argptr;
flagType metaflag;
	{
	cur_file = FileNameToHandle(zero_length,zero_length);
	row = argptr->arg.textarg.y;
	col = argptr->arg.textarg.x;
	cptr = argptr->arg.textarg.pText;
	for (; *cptr; cptr++, col++)
		{
		character = *cptr;
		if (character >= 'a' && character <= 'z')
			{
			character += 'A' - 'a';
			}
		Replace(character,col,row,cur_file,FALSE);
		}
	return(TRUE);
	}



flagType pascal EXTERNAL lower(argtype,argptr,metaflag)
unsigned short argtype;
ARG far *argptr;
flagType metaflag;
	{
	cur_file = FileNameToHandle(zero_length,zero_length);
	row = argptr->arg.textarg.y;
	col = argptr->arg.textarg.x;
	cptr = argptr->arg.textarg.pText;
	for (; *cptr; cptr++, col++)
		{
		character = *cptr;
		if (character >= 'A' && character <= 'Z')
			{
			character += 'a' - 'A';
			}
		Replace(character,col,row,cur_file,FALSE);
		}
	return(TRUE);
	}



WhenLoaded()
	{
	DoMessage("Extended Macros (v 1.2) -- Copyright (c) 1988-89, Chris Laforet.");
	zero_length[0] = (char)'\0';
	SetKey("prnt_time","ctrl+t");
	SetKey("open_hilite","ctrl+o");
	SetKey("special_char","ctrl+g");
	SetKey("upper","ctrl+u");
	SetKey("lower","ctrl+l");
	return(TRUE);
	}



struct swiDesc swiTable[] =
	{
		{NULL,NULL,NULL}
	};


struct cmdDesc cmdTable[] =
	{
		{"prnt_time",prnt_time,NULL,NOARG},
		{"open_hilite",open_hilite,NULL,NOARG},
		{"special_char",special_char,NULL,NOARG},
		{"upper",upper,NULL,BOXSTR | TEXTARG},
		{"lower",lower,NULL,BOXSTR | TEXTARG},
		{NULL,NULL,NULL,NULL}
	};
